#ifndef MPIPE_I_COMMAND_DATA_H
#define MPIPE_I_COMMAND_DATA_H

#include "i_command.h"
#include "core/common_types.h"

namespace mpipe
{

class i_data_object;

class i_command_data : public i_command
{
public:
    using u_ptr_t = std::unique_ptr<i_command_data>;
    using s_ptr_t = std::shared_ptr<i_command_data>;

    virtual command_id_t command_id() const final override { return command_id_t::data; }
    virtual const i_data_object& data() const = 0;
    virtual user_data_type_t data_type() const = 0;
};

}


#endif // MPIPE_I_COMMAND_DATA_H
