#ifndef MPIPE_I_COMMAND_PRESS_KEYS_H
#define MPIPE_I_COMMAND_PRESS_KEYS_H

#include "i_command.h"
#include <vector>

namespace mpipe
{

class i_command_press_keys: public i_command
{
public:
    using key_code_t = std::uint32_t;
    using key_array_t = std::vector<key_code_t>;
    using u_ptr_t = std::unique_ptr<i_command_press_keys>;
    using s_ptr_t = std::shared_ptr<i_command_press_keys>;

    virtual command_id_t command_id() const final override { return command_id_t::press_keys; }

    virtual const key_array_t& keys() const = 0;
};

}


#endif // MPIPE_I_COMMAND_PRESS_KEYS_H
