#ifndef MPIPE_I_QUEUE_H
#define MPIPE_I_QUEUE_H

#include <cstdint>
#include <memory>

namespace mpipe
{

template<class T>
class i_queue
{
public:

    using value_type_t = T;
    using u_ptr_t = std::unique_ptr<i_queue<T>>;
    virtual ~i_queue() = default;

    virtual bool push(value_type_t&& value) = 0;
    virtual value_type_t pop() = 0;
    virtual std::size_t pending() const = 0;
    virtual std::size_t drop() const = 0;
    virtual std::size_t capacity() const = 0;
    virtual void reset() = 0;
};

}

#endif // MPIPE_I_MEDIA_FRAME_QUEUE_H
