#ifndef MPIPE_MEDIA_I_IMAGE_H
#define MPIPE_MEDIA_I_IMAGE_H

#include "video_types.h"
#include <memory>

namespace mpipe
{

class i_data_object;

class i_image
{
public:
    using u_ptr_t = std::unique_ptr<i_image>;
    using s_ptr_t = std::shared_ptr<i_image>;

    virtual ~i_image() = default;
    virtual std::int32_t hot_x() const = 0;
    virtual std::int32_t hot_y() const = 0;
    virtual std::int32_t width() const = 0;
    virtual std::int32_t height() const = 0;
    virtual video_format_id_t format() const = 0;
    virtual const i_data_object& data() const = 0;
    virtual i_image::u_ptr_t clone() const = 0;
};

}

#endif // MPIPE_MEDIA_I_IMAGE_H
