#ifndef MPIPE_MEDIA_FORMAT_DESCRIPTION_H
#define MPIPE_MEDIA_FORMAT_DESCRIPTION_H

#include "variant_info.h"
#include "media_params.h"

#include <vector>


namespace mpipe
{

struct media_format_description_t
{
    using array_t = std::vector<media_format_description_t>;

    variant_info_t      format;
    media_params_t      params;

    media_format_description_t(const variant_info_t& format = {}
                               , const media_params_t& params = {});

    media_format_description_t(const i_media_format& media_format);

    void assign(const i_media_format& media_format);

    bool operator == (const media_format_description_t& other) const;
    bool operator != (const media_format_description_t& other) const;

    bool is_valid() const;

};

}

#endif // MPIPE_MEDIA_FORMAT_DESCRIPTION_H
