#ifndef MPIPE_STATUS_CODES_H
#define MPIPE_STATUS_CODES_H

namespace mpipe
{

enum class status_class_t
{
    undefined = 0,
    information,
    success,
    redirection,
    client_error,
    server_error
};


enum class status_code_t
{
    undefined = 0,

    // information

    cont = 100,
    sw_proto = 101,
    processing = 102,
    early_hints = 103,

    //success

    ok = 200,
    created = 201,
    accepted = 202,
    non_auth_info = 203,
    no_content = 204,
    reset_content = 205,
    partial_content = 206,
    multy_status = 207,
    already_reported = 208,
    im_used = 226,

    // redirection

    multiple_choices = 300,
    moved_permanently = 301,
    found = 302,
    see_other = 303,
    not_modified = 304,
    use_propxy = 305,
    reserved = 306,
    temporary_redirect = 307,
    permanent_redirect = 308,

    // client error

    bad_request = 400,
    unautorized = 401,
    payment_required = 402,
    forriben = 403,
    not_found = 404,
    method_not_allowed = 405,
    not_acceptable = 406,
    proxy_auth_required = 407,
    request_timeout = 408,
    conflict = 409,
    gone = 410,
    length_required = 411,
    precondition_failed = 412,
    payload_too_large = 413,
    uri_too_long = 414,
    unsupported_media_type = 415,
    range_not_satisfiable = 416,
    expectation_failed = 417,
    teapot = 418,
    authentication_timeout = 419,
    misdirected_request = 421,
    unprocessable_entity = 422,
    locked = 423,
    failed_dependency = 424,
    too_early = 425,
    upgrade_required = 426,
    precondition_required = 428,
    too_many_requests = 429,
    request_header_fields_too_large = 431,
    retry_with = 449,
    unavailable_for_legal_reasons = 451,
    resource_busy = 460,
    client_closed_request = 499,

    // server error

    internal_server_error = 500,
    not_implemented = 501,
    bad_gateway = 502,
    service_unavailable = 503,
    gateway_timeout = 504,
    version_not_supported = 505,
    variant_also_negotiates = 506,
    insufficient_storage = 507,
    loop_detected = 508,
    bandwidth_limit_exceeded = 509,
    not_extended = 510,
    network_auth_required = 511,
    unknown_error = 520,
    server_is_down = 521,
    connection_timed_out = 522,
    origin_is_unreachable = 523,
    timeout_occurred = 524,
    ssl_handshake_failed = 525,
    invalid_ssl_certificate = 526
};

}

#endif // MPIPE_STATUS_CODES_H
