#ifndef MPIPE_RTC_I_MEDIA_GRABBER_H
#define MPIPE_RTC_I_MEDIA_GRABBER_H

#include "core/media/i_media_frame.h"

namespace mpipe::wrtc
{

class i_media_grabber
{
public:

    using u_ptr_t = std::unique_ptr<i_media_grabber>;
    using s_ptr_t = std::shared_ptr<i_media_grabber>;

    class i_listener
    {
    public:
        virtual ~i_listener() = default;
        virtual void on_frame(const i_media_frame& media_frame) = 0;
        virtual void on_state(bool started) = 0;
    };

    virtual ~i_media_grabber() = default;
    virtual bool set_listener(i_listener* listener) = 0;
    virtual bool start() = 0;
    virtual bool stop() = 0;
    virtual bool is_started() const = 0;
};

}

#endif // MPIPE_RTC_I_MEDIA_GRABBER_H
