#ifndef I_IO_LINK_H
#define I_IO_LINK_H

#include "io_base.h"
#include <memory>

namespace pt::io
{

class i_io_link
{
public:
    using u_ptr_t = std::unique_ptr<i_io_link>;

    class i_listener
    {
    public:
        virtual ~i_listener() = default;
        virtual void on_message(const message_t& message
                                , const endpoint_t& endpoint) = 0;
        virtual void on_state(link_state_t state, const std::string_view& reason) = 0;
        virtual bool on_link(i_io_link::u_ptr_t&& link) = 0;
    };

    virtual ~i_io_link() = default;
    virtual link_type_t type() const = 0;
    virtual bool control(link_control_id_t control_id) = 0;
    virtual bool send(const message_t& message) = 0;
    virtual bool send_to(const message_t& message
                        , const endpoint_t& endpoint) = 0;
    virtual bool set_listener(i_listener* listener) = 0;

    virtual link_state_t state() const = 0;
    virtual bool is_open() const = 0;
};

}

#endif // I_IO_LINK_H
