#ifndef IO_NET_I_TCP_LINK_H
#define IO_NET_I_TCP_LINK_H

#include "i_socket_link.h"
#include "net_types.h"

namespace pt::io
{

struct tcp_link_options_t;

class i_tcp_link : public i_socket_link
{
public:
    using u_ptr_t = std::unique_ptr<i_tcp_link>;
    virtual ip_endpoint_t remote_endpoint() const = 0;
    virtual bool set_remote_endpoint(const ip_endpoint_t& endpoint) = 0;
    virtual bool set_options(const tcp_link_options_t& options) = 0;
    virtual tcp_link_options_t get_options() const = 0;
    virtual stream_protocol_t stream_protocol() const = 0;
    virtual role_t role() const = 0;
};

}

#endif // IO_NET_I_TCP_LINK_H
