#ifndef IO_NET_I_UDP_LINK_H
#define IO_NET_I_UDP_LINK_H

#include "i_socket_link.h"

namespace pt::io
{

struct udp_link_options_t;

class i_udp_link : public i_socket_link
{
public:
    using u_ptr_t = std::unique_ptr<i_udp_link>;
    virtual ip_endpoint_t remote_endpoint() const = 0;
    virtual bool set_remote_endpoint(const ip_endpoint_t& endpoint) = 0;
    virtual bool set_options(const udp_link_options_t& options) = 0;
    virtual udp_link_options_t get_options() const = 0;
};

}

#endif // IO_NET_I_UDP_LINK_H
