#ifndef PORTABLE_SPC_I_SPACE_H
#define PORTABLE_SPC_I_SPACE_H

#include <string>
#include <memory>

namespace pt::spc
{

struct space_state_t;
struct space_response_t;
struct space_request_t;

class i_space
{
public:
    class i_listener
    {
    public:
        virtual ~i_listener() = default;
        virtual void on_space_response(space_response_t&& response) = 0;
    };
    using u_ptr_t = std::unique_ptr<i_space>;
    using s_ptr_t = std::shared_ptr<i_space>;

    virtual ~i_space() = default;

    virtual bool request(const space_request_t& request) = 0;
    virtual void set_listener(i_listener* listener) = 0;
    virtual std::string name() const = 0;

};

}

#endif // PORTABLE_SPC_I_SPACE_H
