#ifndef PORTABLE_SPC_SPACE_STATE_H
#define PORTABLE_SPC_SPACE_STATE_H

#include "image_view.h"
#include "cursor_state.h"
#include "clipboard_state.h"

namespace pt::spc
{

struct space_state_t
{
    image_view_t        screen_image;
    cursor_state_t      cursor_state;
    clipboard_state_t   clipboard_state;

    space_state_t(const image_view_t& screen_image = {}
                  , const cursor_state_t& cursor_state = {}
                  , const clipboard_state_t& clipboard_state = {});

    bool operator == (const space_state_t& other) const;
    bool operator != (const space_state_t& other) const;
};

}

#endif // SPACE_STATE_H
